require_relative "../lib/hyde/pattern_matching"
require "test/unit"

class TestGlob < Test::Unit::TestCase
  include Hyde::PatternMatching
  # match? test
  def test_matchq
    # testing "*"
    unit = Glob.new("/test/*")
    [
      "est/anything", false,
      "/test", false,
      "/test/anything", true,
      "/test//as", true,
      "/test/", false,
      "/test/as/whatever", true,
      "test/as", true
    ].each_slice(2) do |test, result|
      puts("Testing: #{test}")
      assert_equal(result, unit.match?(test))
    end
    unit = Glob.new("/test/*/something")
    [
      "/test/s/something", true,
      "/test//something", false,
      "/test/something", false,
      "test/b/something", true,
      "/test/b/someth", false
    ].each_slice(2) do |test, result|
      puts("Testing: #{test}")
      assert_equal(result, unit.match?(test))
    end
    # testing "**"
    unit = Glob.new("/test/**/something")
    [
      "/test/s/something", true,
      "/test/dir/something", true,
      "/test/something", true,
      "test/b/something", true,
      "/test/b/someth", false,
      "/test/a/b/c/something", true,
      "/test/a/b/csomething", false,
      "/testsomething", false,
      "/something", false
    ].each_slice(2) do |test, result|
      puts("Testing: #{test}")
      assert_equal(result, unit.match?(test))
    end
    unit = Glob.new("/test/**/*.php")
    [
      "/test/archive.php", true,
      "/test/assets/thing.js", false,
      "/test/assetsthing.js", false,
      "/test/parts/thing.php", true,
      "/test/partsthing.php", true,
      "/test/.php", true,
      "/test/parts/extra/test.php", true,
      "test/archive.php", true,
      "test/assets/thing.js", false,
      "test/assetsthing.js", false,
      "test/parts/thing.php", true,
      "test/partsthing.php", true,
      "test/.php", true,
      "test/parts/extra/test.php", true,
      "/test/parts/extra/test.php/literally/anything/here", true
    ].each_slice(2) do |test, result|
      puts("Testing: #{test}")
      assert_equal(result, unit.match?(test))
    end
    # testing ?
    unit = Glob.new("/test/?hit")
    [
      "/test/thing", false,
      "/test/chit", true,
      "/test//hit", false,
      "/testhit", false
    ].each_slice(2) do |test, result|
      puts("Testing: #{test}")
      assert_equal(result, unit.match?(test))
    end
    # testing char ranges
    unit = Glob.new("/test/[9-z]+")
    [
      "/test/t+", true,
      "/test/$+", false,
      "/test/aosidujqwi", false,
      "/test/9+", true
    ].each_slice(2) do |test, result|
      puts("Testing: #{test}")
      assert_equal(result, unit.match?(test))
    end
    # testing named captures
    unit = Glob.new("/test/:name/something")
    [
      "/test/something/something", true,
      "/test/asd/something/extra", true,
      "/test//something/what", false,
      "/test/something/what", false,
      "/test/asd/asd/something/what", false
    ].each_slice(2) do |test, result|
      puts("Testing: #{test}")
      assert_equal(result, unit.match?(test))
    end
  end

end
